<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
<?xbl href="bindings.xml"?>
<html><head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>X-Smiles.org</title>

<link href="xsmiles_style.css" type="text/css" rel="stylesheet">
<link href="xsmiles_style.html" type="text/css" rel="stylesheet">
<style type="text/css">    table {width:700px;}
  </style>
<style type="text/css">
					td.nav, table.nav, tr.nav,td.contentarea {vertical-align: top; border-width:0px;}
				</style><!--NOTE: THIS FILE IS AUTOMATICALLY GENERATED BY XSL, DO NOT EDIT BY HAND. EDIT FEATURES.XML INSTEAD AND RUN 'build.sh sitedoc--></head><body>
<img alt="X-SMILES.ORG" src="xsmiles.gif"><table class="nav">
<tbody><tr class="nav">
<td class="nav" style="vertical-align: top; width: 100pt;">
     <div id="navbar" class="navbar">
     <div>
     <p id="link-xsmiles" class="link">
      <a class="linkmain" href="index.html">X-Smiles</a>
     </p>
     <p id="link-objectives" class="link">
      <a class="linkmain" href="xsmiles_objectives.html">Objectives</a>
     </p>
     <p id="link-contributors" class="link">
      <a class="linkmain"  href="contributors.html">Contributors</a>
     </p>
     <p id="link-screenshots" class="link">
      <a class="linkmain" href="screenshots.html">Screenshots</a>
     </p>
     <p id="link-downloads" class="link">
      <a class="linkmain" href="download.html">Download</a>
     </p>
     <p id="link-documents" class="link">  
      <a class="linkmain">Documents</a>
      <a class="linksub1" href="xsmiles_features.html">Features</a> 
      <a class="linksub1" href="xsmiles_installation.html">Installation</a>
      <a class="linksub1" href="platforms.html">Platforms</a>
      <a class="linksub1" href="xsmiles_faq.html">FAQ</a>
      <a class="linksub1" href="xsmiles_test.html">Testimonials</a>
     </p>
     <p id="link-developers" class="link">
      <a class="linkmain">Developer Area</a>
      <a class="linksub1" href="participate.html">Participating</a>
      <a class="linksub1" href="techspec.html">Technical Spec</a>
      <a class="linksub1" href="xsmiles_compiling.html">How to compile</a>
      <a class="linksub1" href="xsmiles_future.html">Projects</a>
      <a class="linksub1" href="http://www.xsmiles.org/javadoc/index.html">Javadoc</a>
      <a class="linksub1" href="cvs.html">CVS access</a>
      <a class="linksub1" href="xsmiles_smil.html">SMIL package</a>
      <a class="linksub1" href="http://www.xsmiles.org/demo/demos.xhtml">Demos</a>
     </p>
     <p id="link-reading" class="link">
      <a class="linkmain">Reading</a>
      <a class="linksub1" href="presentations.html">Presentations</a>
      <a class="linksub1" href="publications.html">Publications</a>
     </p>
     <p id="link-feedback" class="link">
      <a class="linkmain">Feedback</a>
      <a class="linksub1" href="http://sourceforge.net/bugs/?group_id=18700"> Bugs</a>
      <a class="linksub1" href="xsmiles_lists.html">Mailing lists</a>
     </p>
    </div>
    </div>
</td><td class="contentarea">
<div class="contentarea">
<h1>X-Smiles 1.1 features</h1>
<h2>Feature table</h2>
<p>The following table briefly lists all the main features of the browser. Click on the links to see more detailed feature lists.</p>
<table border="1">
<tbody>
<tr>
<td align="center" bgcolor="#00ccff" width="33%"><b>Feature</b></td><td align="center" bgcolor="#00ccff" width="47%"><b>Notes</b></td>
</tr>
<tr>
<td width="33%"><b><a href="#xml">XML Parsing</a></b></td><td rowspan="2" width="47%">Using any <a href="http://java.sun.com/xml/">JAXP</a>+namespace capable parser or transformer (e.g. Xerces/Xalan)</td>
</tr>
<tr>
<td width="33%"><b><a href="#xml">XSLT Transforms</a></b></td>
</tr>
<tr>
<td width="33%"><b><a href="#smil">SMIL 2.0 Basic</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="http://www.xsmiles.org/features_xforms.html">XForms</a>&nbsp;</b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="http://www.xsmiles.org/features_css.html">Cascading Stylesheets (CSS)</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="http://www.xsmiles.org/X-Smiles_Muumi_Features.html">XML + CSS Renderer</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="http://www.xsmiles.org/features_xhtml2.html">XHTML 2.0</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="#xslfo">XSL Formatting Objects</a></b></td><td width="47%">Using FOP as the layout/renderer.</td>
</tr>
<tr>
<td width="33%"><b><a href="#svg">SVG</a></b></td><td width="47%">Using CSIRO SVG viewer.</td>
</tr>
<tr>
<td width="33%"><b><a href="#x3d">X3D</a></b></td><td width="47%">Extension: Using Xj3D Open Source VRML/X3D Toolkit.</td>
</tr>
<tr>
<td width="33%"><b><a href="http://www.xsmiles.org/features_xmlsig.html">XML Signature</a></b></td><td width="47%">Extension: Using Apache XML Security</td>
</tr>
<tr>
<td width="33%"><b><a href="#xmlevents">XML Events</a></b></td><td width="47%">Experimental X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="#ecmascript">ECMAScript</a></b></td><td width="47%">Using Rhino engine.</td>
</tr>
<tr>
<td width="33%"><b><a href="#gui">Multiple GUI support/skins</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="#sip">SIP Videoconferencing</a></b></td><td width="47%">X-Smiles feature (using JMF)</td>
</tr>
<tr>
<td width="33%"><b><a href="#timesheet">Timesheets</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
<tr>
<td width="33%"><b><a href="http://www.xsmiles.org/XBL_Implementation_Status.html">XBL 2.0</a></b></td><td width="47%">X-Smiles feature</td>
</tr>
</tbody>
</table>
<p>Please see <a href="http://www.xsmiles.org/release.txt">release.txt</a> for release specific details.</p>
<h2 id="smil">SMIL</h2>
<p>This is an implementation of <a href="http://www.w3.org/TR/smil20/smil-basic.html#smilBasicNS-Basic">SMIL 2.0 Basic Profile</a>. Also, some additional modules have been implemented. Check the table below for some missing features.</p>
<h3>1. Supported features</h3>
<table border="1" width="100%">
<tbody>
<tr>
<td bgcolor="#c0c0c0" width="38%"><b>Feature</b></td><td bgcolor="#c0c0c0" width="13%"><b>Support</b></td><td bgcolor="#c0c0c0" width="49%"><b>Notes</b></td>
</tr>
<tr>
<td colspan="3" align="center" bgcolor="#c0c0c0" width="100%"><font size="2"><b>SMIL 2.0 Basic</b></font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>Structure Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;smil&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">id, class, xml:lang and title attrs ignored.</font> </td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;head&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">id, class, xml:lang and title ignored.</font> </td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;body&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">id, class, xml:lang and title attrs ignored.</font> </td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicContentControl Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; systemAttributes</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;switch&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%">&nbsp;</td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Test Attribute In-line use</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>SkipContentControl Module</b></font></td>
</tr>
<tr>
<td bgcolor="#ffffff" width="38%"><font size="2">&nbsp; skip-content attr.</font></td><td bgcolor="#ffffff" width="13%"><font size="2">No</font></td><td bgcolor="#ffffff" width="49%">&nbsp;</td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>Metainformation Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;meta&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;metadata&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%">&nbsp;</td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicLayout Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;layout&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;region&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;root-layout&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; region attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">Does not render in multiple regions.</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicLinking Module</b></font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; &lt;a&gt;</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">Timing not resolved completely when a link is followed.</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; &lt;area&gt; (&lt;anchor&gt;)</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">nohref, shape attr. missing. No precedence for overlapping areas. See also &lt;a&gt; element.</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicMedia Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;ref&gt;, &lt;animation&gt;, &lt;audio&gt;, &lt;img&gt;, &lt;text&gt;, &lt;textstream&gt; and &lt;video&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">XMLBase namespace not understood.</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicInlineTiming Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; dur attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; begin attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">Negative offsets don't work with repeats.</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; end attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>MinMaxTiming Module</b></font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; min attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">'media' value not done.</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; max attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">'media' value not done.</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicTimeContainers Module</b></font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; &lt;seq&gt;</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">begin attr can be negative.</font> </td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;par&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; fill attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">"transition" works like "freeze". "freeze" does not fill gaps between media in &lt;seq&gt;.</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; endsync attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">SMIL 1.0 id values not supported.</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>RepeatTiming Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; repeatDur attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; repeatCount attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">Can handle only integers if dur is not specified.</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; repeat attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">SMIL 1.0 repeat attr mapped to use repeatCount.</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>SyncbaseTiming Module</b></font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; begin attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">Works only between sibling elements.</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; end attr.</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">Works only between sibling elements.</font></td>
</tr>
<tr>
<td colspan="3" align="center" bgcolor="#c0c0c0" width="100%"><font size="2"><b>Other modules</b></font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>EventTiming Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; begin attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; end attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>CustomTestAttributes Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;customAttributes&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; &lt;customTest&gt;</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">override attribute missing.</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; customTest attr.</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BrushMedia Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;brush&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">inherit attr. is prohibited</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>BasicAnimation Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;animate&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;set&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;animateMotion&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;animateColor&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>MultiWindowLayout Module</b></font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; &lt;topLayout&gt;</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Yes</font></td><td bgcolor="#00ff00" width="49%"><font size="2">&nbsp;</font></td>
</tr>
<tr>
<td colspan="3" width="100%"><font size="2"><b>EventTiming Module</b></font></td>
</tr>
<tr>
<td bgcolor="#ffff00" width="38%"><font size="2">&nbsp; &lt;begin end attr.&gt;</font></td><td bgcolor="#ffff00" width="13%"><font size="2">Partially</font></td><td bgcolor="#ffff00" width="49%"><font size="2">Special cases won't work (restart etc.).</font></td>
</tr>
<tr>
<td colspan="3" bgcolor="#c0c0c0" width="100%"><b>Supported media</b></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Text</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Java</font></td><td bgcolor="#00ff00" width="49%"><font size="2">plain text, very simple xhtml with CSS style for fonts+colors</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Image</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Java</font></td><td bgcolor="#00ff00" width="49%"><font size="2">GIF (transparent &amp; animated), JPEG and PNG (transparent)</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Audio</font></td><td bgcolor="#00ff00" width="13%"><font size="2">Java</font></td><td bgcolor="#00ff00" width="49%"><font size="2">Ogg Vorbis (streamed)</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Audio</font></td><td bgcolor="#00ff00" width="13%"><font size="2">JMF</font></td><td bgcolor="#00ff00" width="49%"><font size="2">AIFF, AU, AVI, GSM, MIDI, MP2, MP3, QT, RMF and WAV</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Video</font></td><td bgcolor="#00ff00" width="13%"><font size="2">JMF</font></td><td bgcolor="#00ff00" width="49%"><font size="2">AVI, MPEG-1, QT, H.261 and H.263</font></td>
</tr>
<tr>
<td bgcolor="#00ff00" width="38%"><font size="2">&nbsp; Other</font></td><td bgcolor="#00ff00" width="13%"><font size="2">XML</font></td><td bgcolor="#00ff00" width="49%"><font size="2">SMIL, XSL FO and SVG</font></td>
</tr>
</tbody>
</table>
<h3>2. Animation</h3>The following target elements can be animated by
the implemented BasicAnimation Module. Note that SplineAnimation Module
has not been implemented. <table border="1" width="100%">
<tbody>
<tr>
<td align="center" bgcolor="#00ccff" width="13%"><b>Elements</b></td><td align="center" bgcolor="#00ccff" width="33%"><b>Target Element</b></td><td align="center" bgcolor="#00ccff" width="34%"><b>Target Attributes</b></td>
</tr>
<tr>
<td rowspan="4" width="13%">animate</td><td width="33%">region</td><td width="34%">left, right, top, bottom, width, height, backgroundColor <i>(z-index and regionName missing)</i></td>
</tr>
<tr>
<td width="33%">area (anchor)</td><td width="34%">Not supported <i>(coords missing)</i></td>
</tr>
<tr>
<td width="33%">text, img, audio, animation, video, ref, textstream</td><td width="34%">Not supported <i>(HierarchicalLayout Module missing)</i></td>
</tr>
<tr>
<td width="33%">brush</td><td width="34%">color <i>(HierarchicalLayout Module missing)</i></td>
</tr>
<tr>
<td rowspan="4" width="13%">set</td><td width="33%">region</td><td width="34%">left, right, top, bottom, width, height, backgroundColor <i>(z-index and regionName missing)</i></td>
</tr>
<tr>
<td width="33%">area (anchor)</td><td width="34%">Not supported <i>(coords missing)</i></td>
</tr>
<tr>
<td width="33%">text, img, audio, animation, video, ref, textstream</td><td width="34%">Not supported <i>(HierarchicalLayout Module missing)</i></td>
</tr>
<tr>
<td width="33%">brush</td><td width="34%">color <i>(HierarchicalLayout Module missing)</i></td>
</tr>
<tr>
<td rowspan="2" width="13%">animateMotion</td><td width="33%">region</td><td width="34%">left, top</td>
</tr>
<tr>
<td width="33%">text, img, audio, animation, video, ref, textstream</td><td width="34%">Not supported <i>(HierarchicalLayout Module missing)</i></td>
</tr>
<tr>
<td rowspan="3" width="13%">animateColor</td><td width="33%">region</td><td width="34%">backgroundColor</td>
</tr>
<tr>
<td width="33%">text, img, audio, animation, video, ref, textstream</td><td width="34%">Not supported <i>(HierarchicalLayout Module missing)</i></td>
</tr>
<tr>
<td width="33%">brush</td><td width="34%">color</td>
</tr>
</tbody>
</table>
<h3>3. Events</h3>Currently, the elements send the following events. These can be listened by EventTiming module or XML Events. <table border="1" width="100%">
<tbody>
<tr>
<td align="center" bgcolor="#00ccff" width="23%"><b>Event</b></td><td align="center" bgcolor="#00ccff" width="47%"><b>Notes</b></td>
</tr>
<tr>
<td width="23%">beginEvent</td><td width="47%">When an element starts. No bubbling.</td>
</tr>
<tr>
<td width="23%">endEvent</td><td width="47%">When an element ends. No bubbling.</td>
</tr>
<tr>
<td width="23%">repeatEvent</td><td width="47%">When an element repeats. No bubbling.</td>
</tr>
<tr>
<td width="23%">activateEvent</td><td width="47%">When an element is clicked. No bubbling.</td>
</tr>
<tr>
<td width="23%">inBoundsEvent</td><td width="47%">When mouse enters over an element. No bubbling.</td>
</tr>
<tr>
<td width="23%">outOfBoundsEvent</td><td width="47%">When mouse moves out of an element. No bubbling.</td>
</tr>
<tr>
<td width="23%">topLayoutOpenEvent</td><td width="47%">SMIL MultiWindowLayout event. When a toplayout opens. No bubbling.</td>
</tr>
<tr>
<td width="23%">topLayoutCloseEvent</td><td width="47%">SMIL MultiWindowLayout event. When a toplayout closes. No bubbling.</td>
</tr>
<tr>
<td width="23%">click</td><td width="47%">DOM Mouse Event. When an element is clicked. Bubbles.</td>
</tr>
<tr>
<td width="23%">mouseover</td><td width="47%">DOM Mouse Event. When mouse moves over an element. Bubbles.</td>
</tr>
<tr>
<td width="23%">mouseout</td><td width="47%">DOM Mouse Event. When mouse moves out of an element. Bubbles.</td>
</tr>
<tr>
<td width="23%">mousedown</td><td width="47%">DOM Mouse Event. When mouse button is pressed. Bubbles.</td>
</tr>
<tr>
<td width="23%">mouseup</td><td width="47%">DOM Mouse Event. When mouse button is released. Bubbles.</td>
</tr>
</tbody>
</table>
<h3>4. Dynamic SMIL</h3>An extended <a href="http://www.w3.org/TR/smil-boston-dom/">SMIL-DOM</a> is supported. Also, the following methods can be used to begin and end elements in scripts. <ul>
<li>beginElement()</li>
<li>beginElementAt(int)</li>
<li>endElement()</li>
<li>endElementAt(int)</li>
</ul>
<h3>5. Notes</h3>
<ul>
<li>For details about supported media formats when using JMF 2.1.1, see <a href="http://java.sun.com/products/java-media/jmf/2.1.1/formats.html">JMF 2.1.1 Supported Formats</a>.</li>
<li>Ogg Vorbis is supported without JMF. The media is streamed. It
won't work if JMF has been used. Player implemented by JCraft,
www.jcraft.com</li>
<li>rtsp protocol can be used within SMIL docs, but rtsp tunneling via http is not supported.</li>
<li>Links into middle of a document causes errors - the parent time
containers will not know the correct position. The links also confuse
the end of the SMIL presentation.</li>
<li>Syncbase timing (id.begin+2s) works only between sibling elements, not over time containers.</li>
<li>SMIL 1.0 support is minimal. SMIL 1.0 id values not supported. SMIL 1.0 system attributes do work.</li>
<li>repeat attribute doesn't work as SMIL 1.0 specification defines it.</li>
<li>SMIL basic layout language is supported. Also, alternative CSS layout model (type="text/css") is supported.</li>
<li>There is no strict validation for the SMIL files.</li>
<li>Scripting is possible using XML Events. See the demo for details.</li>
<li>Note: XPointer doesn't work in links (not required by the spec).</li>
<li>To use the standalone SMIL players, see <a href="http://www.xsmiles.org/xsmiles_smil.html">the instructions</a>.</li>
<li>systemComponent attribute currently understands one URI: "http://www.x-smiles.org".</li>
<li>The meta element's base attribute is supported. XMLBase attribute is not implemented.</li>
<li>Element restart behaviour is not well supported.</li>
</ul>
<h2 id="xforms">XForms</h2>
<p>See the <a href="http://www.xsmiles.org/features_xforms.html">XForms features</a> document.</p>
<h2 id="svg">SVG</h2>
<h3>1. Supported features</h3>SVG (Scalable Vector Graphics) is
supported in X-Smiles by an embedded viewer. This viewer is the August
6th 2000 release&nbsp; of the CSIRO SVG Toolkit (open source). It
supports the <a href="http://www.w3.org/TR/2000/CR-SVG-20000802/">W3C SVG Candidate Recommendation</a> (2 Aug 2000). <h2 id="x3d">X3D</h2>
<h3>1. Supported features</h3>
<p>X3D (Extensible 3D Graphics) is supported in X-Smiles by an embedded
viewer. This viewer is the M4 release of the Xj3D Open Source VRML/X3D
Toolkit (open source). It supports the <a href="http://www.web3d.org/x3d.html">Web3D X3D Specification</a>. See the <a href="http://www.web3d.org/TaskGroups/source/xj3d.html">Xj3D web site</a> for details about the viewer.</p>
<p>Note that viewing X3D documents requires installing the Java3D package, see <a href="http://www.xsmiles.org/xsmiles_installation.html">installation</a> for details.</p>
<p>Displaying X3D documents also requires <a href="http://www.xsmiles.org/xsmiles_installation.html#extensions">installing an Extension MLFC</a>.</p>
<h2 id="css">Cascading Stylesheets</h2>
<p>See <a href="http://www.xsmiles.org/features_css.html">CSS implementation chart</a>.</p>
<h2 id="xhtml">XHTML</h2>
<p>
<a href="http://www.xsmiles.org/features_xhtml.html">XHTML Basic implementation chart</a>.</p>
<p>
<a href="http://www.xsmiles.org/features_xhtml2.html">XHTML 2.0 implementation chart</a>.</p>
<h2 id="sip">SIP</h2>
<h3>Supported features:</h3>
<h4>Authentication:</h4>
<p>Only Digest authentication with MD5 algorithm is supported.</p>
<h4>Registration:</h4>
<p>Registration to proxyserver is supported.</p>
<h4>Calls:</h4>
<p>Basic calls with or without proxies are supported. This includes unsuccesfull call attempts (busy, declined and canceled calls)</p>
<h4>RTP streams:</h4>
<p>Videocapturing and sound capturing. Can send H263/RTP and GSM
streams. Can receive ulaw,gsm, G723, DVI, JPEG and H263 RTP streams.</p>
<p>Calls and server registration&amp;authentication have been tested with sip.sipcenter.com server and Columbia University's SIPC.</p>
<h3>Testing instructions:</h3>
<h4>As a standalone application:</h4>
<p>java fi.hut.tml.xsmiles.sip.SipXSmilesClient username (audioport)
(videoport) (videoCapture) (servername) (passwd), where videoCapture is
true or false and servername + passwd makes this program to operate
with proxy.</p>
<p>Default values are:<br>audioport = 2000<br>videoport=3000<br>videoCapture=false</p>
<h4>With xsmiles:</h4>
<p>Open 'sip.fo' page.</p>
<h2 id="xmlevents">XML Events</h2>
<p class="MsoNormal">X-Smiles has full implementation of the <a href="http://www.w3.org/TR/2001/WD-xml-events-20011026/">XML Events Last Call Working Draft</a>.</p>
<p class="MsoNormal">
<span style="">For examples, see the SMIL/XForms scripting demos.</span>
</p>
<p class="MsoNormal">
<span style="">The scripting language used is EcmaScript, see below.</span>
<br>
</p>
<h2 id="ecmascript">EcmaScript</h2>X-Smiles uses an embedded <a href="http://www.mozilla.org/rhino/">Rhino</a> EcmaScript interpreter to evaluate EcmaScript in the documents.&nbsp; <h4>EcmaScript binding for DOM level 2 is provided:</h4>
<pre>textnode = document.getElementsByTagName("name").item(0).getFirstChild();<br>textelem.setNodeValue("Changed by ECMAScript");</pre>
<p>
<b>SMIL</b> supports changing most of the attributes. Timing attributes should not be changed.</p>
<p>
<b>XForms</b> supports interactively changing the instance data and most of the mouse events.</p>
<p>
<b>SVG</b> supports complete interactivity.</p>
<p>
<b>XSLFO</b> does not currently support interactively changing the document.</p>
<h4>Browser object.</h4>
<pre>browser.alert("Alert from ECMAScript");<br>browser.print("debug");<br>browser.println("debug");<br>browser.navigate("http://www.x-smiles.org/")</pre>
<h4>Navigator object.</h4>As in other browsers. <h2 id="xslfo">XSL Formatting Objects</h2>
<h3>1. General</h3>XSL Formatting Objects are supported with the <a href="http://xml.apache.org/fop/">Apache FOP viewer</a> as the basis. Currently the version 0.20.1 is used. FOP supports the <a href="http://www.w3.org/TR/2000/CR-xsl-20001121/">November 2000 W3C Candidate Recommendation</a> with some limitations. <h3>2. Limitations</h3>
<p>The viewer has the limitations concerning XSL FO listed in&nbsp; <a href="http://xml.apache.org/fop/limitations.html">FOP' s limitations</a>.</p>
<p>The limitations of FOP itself include:</p>
<ul>
<li>FOP's AWTRenderer is a previewer, which prints contents one page at
the time to a graphics object. Therefore changing content after
rendering or using an active background would need rewrite of the
renderer to use awt/swing components.</li>
<li>Scripting is not supported. Adding script support could be
laborious, because DOM tree is no longer visible to the renderer, which
handles the FOP Area Tree.&nbsp;</li>
</ul>
<h3>3. Extensions</h3>
<ul>
<li>Limited support of XForms</li>
<li>External basic links (fo:basic-link element with external destination)</li>
<li>Relative URL support in external images</li>
<li>The use of Java font metrics instead of PDF font metrics as in original FOP.</li>
<li>Support of Java 1.1 in the AWT Viewer.</li>
</ul>
<h2 id="xml">XML and XSLT</h2>X-Smiles supports any <a href="http://java.sun.com/xml/">JAXP</a> capable namespace-aware XML parser/ XSLT transformer. The tested ones are <a href="http://xml.apache.org/xerces-j/index.html">Xerces</a> parser (2.3.0) and <a href="http://xml.apache.org/xalan-j/index.html">Xalan</a> (2.3.1). <h2 id="gui">Multiple GUIs / skins</h2>
<p>X-Smiles has multiple GUIs (Phone, Mobile, FTV and Tabbed) and
supports the changing of GUI's while running. It is even possible to
change GUI while watching a SMIL presentation.</p>
<h2 id="timesheet">Timesheets</h2>
<p>X-Smiles has an implementation of Timesheets. It is based on a <a href="http://homepages.cwi.nl/%7Elynda/www9/Timesheets.www9.html">paper</a> by Kate, W. et. al. and SMIL 2.0.</p>
<p>The implementation supports sequential, parallel and exclusive time
containers, prefetching the contents, repeating, dispatching and
listening to XMLEvents and setting a certain CSS pseudo-class to an
element (<i>class</i> attribute of &lt;item&gt;)</p>
<table border="1" width="100%">
<tbody>
<tr>
<td bgcolor="#c0c0c0" width="34%"><b>Feature</b></td><td bgcolor="#c0c0c0" width="33%"><b>Attributes</b></td><td bgcolor="#c0c0c0" width="33%"><b>Notes</b></td>
</tr>
<tr>
<td>&lt;timesheet&gt;</td><td>-</td><td>Root element</td>
</tr>
<tr>
<td colspan="3"><b>Time containers</b></td>
</tr>
<tr>
<td>&lt;seq&gt;</td><td>begin, dur, repeat</td><td>Sequential time container</td>
</tr>
<tr>
<td>&lt;par&gt;</td><td>begin, dur, repeat</td><td>Parallel time container</td>
</tr>
<tr>
<td>&lt;excl&gt;</td><td>begin, dur, repeat</td><td>Exclusive time container</td>
</tr>
<tr>
<td colspan="3"><b>Item element</b></td>
</tr>
<tr>
<td>&lt;item&gt;</td><td>select, prefetch, class, begin, dur, repeat</td><td>Item element</td>
</tr>
</tbody>
</table>
<p>A short example of Timesheets. There's a few more in the demos of X-Smiles</p>
<pre>&lt;html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:time="http://www.x-smiles.org/2004/timesheet" 
      xmlns:ev="http://www.w3.org/2001/xml-events"&gt;

  &lt;head&gt;

    &lt;time:timesheet&gt;
      &lt;time:seq&gt;

        &lt;time:par&gt;
          &lt;time:item select="#slide1"/&gt;
          &lt;time:item select="#pagenum1"/&gt;
          &lt;time:item select="#bullet1" begin="2s"/&gt;
          &lt;time:item select="#bullet2" begin="4s"/&gt;
          &lt;time:item select="#bullet3" begin="6s"/&gt;
          &lt;time:item select="#bullet4" begin="8s"/&gt;
          &lt;time:item select="#continue" begin="10s"/&gt;
        &lt;/time:par&gt;

        &lt;time:par begin="continue.DOMActivate"&gt;
          &lt;time:item select="#slide2"/&gt;
          &lt;time:item select="#pagenum2"/&gt;
          &lt;time:item select="#bullet5" begin="2s"/&gt;
          &lt;time:item select="#bullet6" begin="4s"/&gt;
        &lt;/time:par&gt;

      &lt;/time:seq&gt;
    &lt;/time:timesheet&gt;
  &lt;/head&gt;

  &lt;body&gt;
    &lt;div id="slide1"&gt;
      &lt;p&gt;Introduction&lt;/p&gt;
      &lt;p id="bullet1"&gt;o Some intro to WLAN&lt;/p&gt;
      &lt;p id="bullet2"&gt;o Some intro to WLAN&lt;/p&gt;
      &lt;p id="bullet3"&gt;- Subbullet&lt;/p&gt;
      &lt;p id="bullet4"&gt;- Subbullet&lt;/p&gt;
      &lt;p id="pagenum1"&gt;1&lt;/p&gt;
      &lt;a href="" id="continue" ev:event="DOMActivate" 
        ev:defaultAction="cancel"&gt;Next slide&lt;/a&gt;
    &lt;/div&gt;

    &lt;div id="slide2"&gt;
      &lt;p&gt;Technology&lt;/p&gt;
      &lt;p id="bullet5"&gt;o Details about WLAN&lt;/p&gt;
      &lt;p id="bullet6"&gt;- Subbullet&lt;/p&gt;
      &lt;p id="pagenum2"&gt;2&lt;/p&gt;
    &lt;/div&gt;
  &lt;/body&gt;
&lt;/html&gt;

</pre>
<hr>
		  Copyright (c) 2000-2007 X-Smiles.org et.al.
	</div>
</td>
</tr>
</tbody></table>

</body></html>